## CONTENTS OF THE FILE

- Introduction
- Configuration
- Real life examples
- Maintainers

## INTRODUCTION

- A D8 / D9 module focused on javascript loading improvements

- Traditionnally, all the javascript of a page is loaded during page load.
  Best case scenario, it's loaded using defer (so towards the end).
  And using async is usually a mess as it does not manage dependancies
  between scripts.

- This modules allows to see the javascripts that are loaded on a page.
  You can then decide to remove them if they are not useful.
  Or you can decide to load them at a later stage if they are not on the
  critical path of rendering.

- Doing this lightens the load on the browser and allows to serve useful
  content to the user faster.

- This will in turn improve your lighthouse / page speed insights analytics
  which is a very important matter for SEO (better ranking with google).

- As an example, without optimizing any javascripts, on a site I am developping,
  I went from 57 to 79 in page speed insights for mobile with only a very light
  configuration.

- This module is more towards developpers as you need to understand the scripts
  that are loaded and their dependancies to avoid breaking the display.

- Helpfully, the debug mode helps you see which scripts are being loaded on a
  page and the order of the download / execution of scripts through this module.

- Bonus: It plays well with advagg, as the hook to remove javascripts from
  being loaded are ran right before advagg ones.

## REQUIREMENTS

* N/A

## RECOMMENDED MODULES

* N/A

## INSTALLATION

* Install as any Drupal D8 / D9 module

## CONFIGURATION

- After the module is enabled, go to the Admin page where all the settings are.

- You can then define a chain of groups of javascript that will be removed from
  standard page load, and loaded at a later stage through an ajax call. You
  specify the delay between the window.load event and the first group as well as
  between groups.

- Eg: `Load -> 100ms -> Group 1 (important js) -> 300ms -> Group 2 (mid important
  js) -> 1000ms -> Group 3 (less important js)`.

- For each group, you can define if they should all be loaded in parallel
  asynchronuously (if you don't mind which one will be executed when) or in a
  synchronized manner if there are dependancies between scripts.
  **Note:** If you are loading scripts that are using behaviors, you should use
  the synchronized way of loading so that attachBehaviors() is called.

- You can also define whether (local) scripts should be aggregated.

## REAL LIFE EXAMPLES

- You can check https://www.discovereef.com to see it in effect.
  If you are using this module and want to showcase it, create a ticket in the
  contact queue or contact me via message and I'll update this section.

## MAINTAINERS

- vdsh - https://www.drupal.org/u/vdsh

